-----

Documentation: [html](https://docs-beta.ethers.io/)

-----


Utilities
=========


These utilities are used extensively within the library, but
are also quite useful for application developers.


* [Addresses](address)
* [BigNumber](bignumber)
  * [Types](bignumber)
  * [Creating Instances](bignumber)
  * [Methods](bignumber)
  * [Notes](bignumber)
* [Byte Manipulation](bytes)
  * [Types](bytes)
  * [Inspection](bytes)
  * [Converting between Arrays and Hexstrings](bytes)
  * [Array Manipulation](bytes)
  * [Hexstring Manipulation](bytes)
  * [Signature Conversion](bytes)
* [Constants](constants)
  * [Bytes](constants)
  * [Strings](constants)
  * [BigNumber](constants)
* [Display Logic and Input](display-logic)
  * [Units](display-logic)
  * [Functions](display-logic)
* [FixedNumber](fixednumber)
  * [Types](fixednumber)
  * [Creating Instances](fixednumber)
  * [Properties](fixednumber)
  * [Methods](fixednumber)
* [Hashing Algorithms](hashing)
  * [Cryptographic Hashing](hashing)
  * [Common Hashing Helpers](hashing)
  * [Solidity Hashing Algorithms](hashing)
* [Strings](strings)
  * [Bytes32String](strings)
  * [UTF-8 Strings](strings)



-----
**Content Hash:** ae9deb0419f2da1644ae9588d27ecc475961b741fa9d7b27b2cf13ddf62d50b6