-----

Documentation: [html](https://docs-beta.ethers.io/)

-----


Constants
=========


The **ethers.contants** Object contains commonly used values.


### Importing



```javascript
Skipping JavaScript Evaluation.
```



Bytes
-----



#### *constants* . **AddressZero** **=>** *[DataHexstring](../bytes)*

The Address Zero, which is 20 bytes (40 nibbles) of zero.




#### *constants* . **HashZero** **=>** *[DataHexstring](../bytes)*

The Hash Zero, which is 32 bytes (64 nibbles) of zero.




Strings
-------



#### *constants* . **EtherSymbol** **=>** *string*

The Ether symbol, **&Xi;**.




BigNumber
---------



#### *constants* . **NegativeOne** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing `"-1"`.




#### *constants* . **Zero** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing `"0"`.




#### *constants* . **One** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing `"1"`.




#### *constants* . **Two** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing `"2"`.




#### *constants* . **WeiPerEther** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing `"1000000000000000000"`, which is the
number of Wei per Ether.




#### *constants* . **MaxUint256** **=>** *[BigNumber](../bignumber)*

The BigNumber value representing the maximum `uint256` value.





-----
**Content Hash:** 11a9a2e37a2a553b79931caf5374bcd894edf343a897c4253ddeaf4d2f8e1213